# [config]
# skip_core_tasks = true

[tasks.patch-and-revert]
category = "anagolay"
condition = { profiles = ["production"] }
description = "Add 'type'='module|commonjs' to build artifacts"
script = '''
#!/usr/bin/env bash

PROJECT_ROOT=$(git rev-parse --show-toplevel)

echo "Patching the package.json files ..."
node "$PROJECT_ROOT"/scripts/patch-package-json.js

echo "Discarding the Cargo.toml changes" 
git checkout -q -- Cargo.toml
'''

[tasks.add-lib]
category = "anagolay"
condition = { profiles = ["production"] }
description = "Add correct [lib] entries to the Cargo.toml for wasm compilation"
script = '''
#!/usr/bin/env bash

PROJECT_ROOT=$(git rev-parse --show-toplevel)

echo "Adding [lib] to Cargo.toml for wasm build ..."
printf "\n[lib]\ncrate-type = [\"cdylib\", \"rlib\"]\n" >> "$PROJECT_ROOT"/Cargo.toml
'''

[tasks.manifest]
category = "anagolay"
condition = { profiles = ["production"] }
args = ["run", "--release", "--", "--manifest"]
command = "cargo"
description = "Genreate Operation manifest via the operation cli flag"


[tasks.esm-release]
condition = { profiles = ["production"] }
category = "anagolay"
args = [
  "build",
  "--target",
  "bundler",
  "--out-dir",
  "pkg/release/esm",
  "--release",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the native ESM in release mode"

[tasks.esm-dev]
condition = { profiles = ["development"] }
category = "anagolay"
args = [
  "--log-level",
  "warn",
  "--verbose",
  "build",
  "--target",
  "bundler",
  "--out-dir",
  "pkg/dev/esm",
  "--dev",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the bundler in dev mode"
watch = true

[tasks.web-release]
condition = { profiles = ["production"] }
category = "anagolay"
args = [
  "build",
  "--target",
  "web",
  "--out-dir",
  "pkg/release/web",
  "--release",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the web in release mode"

[tasks.web-dev]
condition = { profiles = ["development"] }
category = "anagolay"
args = [
  "--log-level",
  "warn",
  "--verbose",
  "build",
  "--target",
  "web",
  "--out-dir",
  "pkg/dev/web",
  "--dev",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the web in dev mode"
watch = true

[tasks.cjs-release]
condition = { profiles = ["production"] }
category = "anagolay"
args = [
  "build",
  "--target",
  "nodejs",
  "--out-dir",
  "pkg/release/cjs",
  "--release",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the nodejs in release mode"

[tasks.cjs-dev]
condition = { profiles = ["development"] }
category = "anagolay"
args = [
  "--log-level",
  "warn",
  "--verbose",
  "build",
  "--target",
  "nodejs",
  "--out-dir",
  "pkg/dev/cjs",
  "--dev",
  "--debug",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the nodejs in dev mode"

[tasks.no-modules-release]
condition = { profiles = ["production"] }
category = "anagolay"
args = [
  "build",
  "--target",
  "no-modules",
  "--out-dir",
  "pkg/release/no-modules",
  "--release",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the nodejs in release mode"

[tasks.no-modules-dev]
condition = { profiles = ["development"] }
category = "anagolay"
args = [
  "--log-level",
  "warn",
  "--verbose",
  "build",
  "--target",
  "no-modules",
  "--out-dir",
  "pkg/dev/no-modules",
  "--dev",
  "--debug",
  "--",
  "--features",
  "js",
]
command = "wasm-pack"
description = "Build the WASM-PACK for the nodejs in dev mode"
watch = true

[tasks.operation-flow]
category = "anagolay"
condition = { profiles = ["production"] }
run_task = { name = [
  "add-lib",
  "esm-release",
  "cjs-release",
  "web-release",
  "no-modules-release",
  "patch-and-revert",
] }
#  parallel = true }

[tasks.artifact-check]
condition = { profiles = ["production"] }
category = "anagolay"
description = "Use prettier to check the code in current directory. This must be invoked with --makefile ../path/to/Makefile.toml."
script = "pnpm dlx prettier --config .prettierrc --check *.{js,d.ts,json}"

[tasks.artifact-format]
condition = { profiles = ["production"] }
category = "anagolay"
description = "Use prettier to format the code. This must be invoked with --makefile ../path/to/Makefile.toml."
script = "pnpm dlx prettier --config .prettierrc --write *.{js,d.ts,json}"

[tasks.test]
description = "Execute unit and integration tests"
command = "cargo"
args = ["test", "--features", "test", "${@}"]
